% 16 mai 2020
% 20 mai 2020 : operations with squares matrices
% manuel.luque27@gmail.com
% les defintions pour les operations sur les complexes
/pst-Theodorus-Spiral {
 20 dict begin
 /a exch def
 /z exch def
 /N exch def
/Imul{% produit de 2 nombres complexes
% z1*z2 => z
6 dict begin
/z2 exch def
/z1 exch def
/x1 z1 0 get def
/y1 z1 1 get def
/x2 z2 0 get def
/y2 z2 1 get def
[
x1 x2 mul y1 y2 mul sub
x1 y2 mul x2 y1 mul add
]
end
} def 
/Iabs{% module d'un complexe
3 dict begin
/z exch def
/x z 0 get def
/y z 1 get def
x dup mul y dup mul add sqrt 
end
} def
/Iadd { % addition de 2 complexes
% z1*z2 => z
6 dict begin
/z2 exch def
/z1 exch def
/x1 z1 0 get def
/y1 z1 1 get def
/x2 z2 0 get def
/y2 z2 1 get def
[x1 x2 add  y1 y2 add]
end
} def 
/Irmul {% multiplier un complexe par un rel
2 dict begin
/z exch def
/r exch def
[z {r mul} forall]
end
} def

SpecialCases {
RandomTheodorusSpiral {
/I0 [0 1] def
/II I0 def
/I^d { % calcule i^d
/r exch def
r {
I0 II Imul
/I0 exch def
} repeat
I0
} def

/d { % nombre alatoire entre 0 et 7
rand 2147483647 div
7 mul
cvi
} def

/SpiraleTheodorus  [
N {
z dup
d I^d z Imul 1 z Iabs div exch Irmul Iadd
/z exch def
} repeat
] def
}if
PyrotechnicSpiral {
/omega 0.7856 def
/p 1.1 def
/d {180 omega mul n p exp mul dup sin exch cos} def
/SpiraleTheodorus [
/n 0 def
N {
z dup
%d I^d z Imul 1 z Iabs div exch Irmul Iadd
1 z Iabs div  
[180 omega mul n p exp mul dup sin exch cos exch ] z Imul 
Irmul Iadd
/z exch def
/n n 1 add def
} repeat
 ] def
 } if 
TrigonometricSum {
/w 0.3299 def
/p 1.781237 def
/z [1 0] def
/n 0 def
% page 24 
/SpiraleTheodorus [
1000 {
z dup
/d [w n p exp mul 180 mul dup cos exch sin exch] def
d
z Iadd 
/z exch def
/n n 1 add def
} repeat
] def
} if 
 }{
 /SpiraleTheodorus [
/n 0 def
N{
 /b [coeffb] def
  a z Imul
  1 z Iabs div 
  b z Imul
  Irmul
  Iadd
  dup /z exch def
 /n n 1 add def
}repeat
 ] def
 } ifelse
DrawSpirals
} def
%

/pst-Theodorus-Spiral-AB {
20 dict begin
% N V A B
/N exch def
/V exch def
/A exch def
/B exch def
%operations with squares matrices
 % produit d'une matrice 2x2 par un vecteur 2
% M V MV -> V'
[[0.2374 0.9721] [-0.9721 0.2374] ] % A
[ 1 0.5 ] % V
/MV {
2 dict begin
/V exch def
/M exch def
[ 
M 0 get 0 get V 0 get mul
M 0 get 1 get V 1 get mul
add
M 1 get 0 get V 0 get mul
M 1 get 1 get V 1 get mul
add
]
end
} def

% produit d'un rel par un vecteur
% r V rV -> V'
/rV {
2 dict begin
/V exch def
/r exch def
[V 0 get r mul
 V 1 get r mul
]
end
} def

% V normeV -> ||V||
/normeV {
1 dict begin
/V exch def
	V 0 get dup mul
	V 1 get dup mul add 
	sqrt
end
} def

% V1+V2
/Vadd {
2 dict begin
/V2 exch def
/V1 exch def
 [V1 0 get V2 0 get add
  V1 1 get V2 1 get add
  ]
end
}def
/SpiraleTheodorus [
N {
 V A V  MV % Avn
 B 
 1 V normeV div % 1/||vn||
 V rV % vn/||vn||
 MV % Bvn
 Vadd % Avn+Bvn/||vn||
/V exch def
} repeat
] def
DrawSpirals
end
 } def

/DrawSpirals {
 ConnectPoints {
 1 setlinejoin
 LineColor
 SpiraleTheodorus 0 get aload pop cm exch cm exch moveto
 1 1 SpiraleTheodorus length 1 sub {/i exch def
  SpiraleTheodorus i get aload pop cm exch cm exch lineto
  } for
 DotSize
  stroke
 } if
 ShowPoints {
 0 1 SpiraleTheodorus length 1 sub {/i exch def
 RainbowColors {i N div 1 1 sethsbcolor} { LineColor } ifelse
 SpiraleTheodorus i get aload pop cm exch cm exch DotSize 0 360 arc fill
  } for
} if
} def
